Index: trunk/MagicSoft/Mars/mcalib/MCalibColorSet.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibColorSet.cc	(revision 9036)
+++ trunk/MagicSoft/Mars/mcalib/MCalibColorSet.cc	(revision 9313)
@@ -57,5 +57,4 @@
 
 const Int_t  MCalibColorSet::gkIFAEBoxInaugurationRun = 20113;
-const Int_t  MCalibColorSet::gkMCRunLimit             = 1000;
 const UInt_t MCalibColorSet::gkFirstRunWithFinalBits  = 45626;
 
@@ -193,7 +192,7 @@
       *fLog << inf << "Run taken before inauguration of IFAE-box... using CT1 pulser." << endl;
       fColor    = MCalibrationCam::kCT1;
+      fStrength = 10.;
       fPattern->SetPulserColor(fColor);
       fPattern->SetPulserStrength(fStrength);
-      fStrength = 10.;
       fIsValid  = kTRUE;
       return kTRUE;
@@ -341,5 +340,4 @@
       *fLog << err << "Sorry, run 27474 was taken with CLOSED LIDS. It should not be used! " << endl;
       return kFALSE;
-      break;
 
     case 40493:
@@ -351,5 +349,4 @@
       *fLog << err << "the camera. It cannot be used for the standard calibration " << endl;
       return kFALSE;
-      break;
       
     case 45605:
@@ -357,5 +354,4 @@
       *fLog << err << "It cannot be used for calibration. Try to run a pedestal extraction on it." << endl;
       return kFALSE;
-      break;
 
     case 45606:
@@ -363,5 +359,4 @@
       *fLog << err << "It cannot be used for calibration. Try to run a pedestal extraction on it." << endl;
       return kFALSE;
-      break;
 
     }
Index: trunk/MagicSoft/Mars/mcalib/MCalibColorSet.h
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibColorSet.h	(revision 9036)
+++ trunk/MagicSoft/Mars/mcalib/MCalibColorSet.h	(revision 9313)
@@ -19,5 +19,4 @@
 
   static const Int_t gkIFAEBoxInaugurationRun; //! Run number of first IFAE box calibration (set to: 20113)
-  static const Int_t gkMCRunLimit;             //! Maximum MC run number (now set to: 1000)
   static const UInt_t gkFirstRunWithFinalBits; //! Run number of first functionning digital modules 
   
Index: trunk/MagicSoft/Mars/mcalib/MCalibrateData.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibrateData.cc	(revision 9036)
+++ trunk/MagicSoft/Mars/mcalib/MCalibrateData.cc	(revision 9313)
@@ -1,4 +1,4 @@
 /* ======================================================================== *\
-! $Name: not supported by cvs2svn $:$Id: MCalibrateData.cc,v 1.72 2008-07-22 18:55:08 tbretz Exp $
+! $Name: not supported by cvs2svn $:$Id: MCalibrateData.cc,v 1.73 2009-02-11 10:48:24 tbretz Exp $
 ! --------------------------------------------------------------------------
 !
@@ -683,5 +683,5 @@
     {
         *fLog << err << GetDescriptor() << ": ERROR - ";
-        *fLog << "GetConversionFactor has skipped more than 90% of the pixels... abort." << endl;
+        *fLog << "GetConversionFactor has skipped more than 90% of the " << fGeomCam->GetNumPixels() <<  " pixels... abort." << endl;
         return kFALSE;
     }
Index: trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.cc	(revision 9036)
+++ trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.cc	(revision 9313)
@@ -1,4 +1,4 @@
 /* ======================================================================== *\
-! $Name: not supported by cvs2svn $:$Id: MCalibrationChargeCalc.cc,v 1.184 2008-06-02 08:46:44 tbretz Exp $
+! $Name: not supported by cvs2svn $:$Id: MCalibrationChargeCalc.cc,v 1.185 2009-02-11 10:48:24 tbretz Exp $
 ! --------------------------------------------------------------------------
 !
@@ -665,6 +665,6 @@
   if (fPulserColor == MCalibrationCam::kNONE)
   {
-      *fLog << warn << "WARNING - No Pulse colour has been set or used at all..." << endl;
-      return kTRUE;
+      *fLog << err << "ERROR - No event was flagged with a pulser color... no calibration possible." << endl;
+      return kFALSE;
   }
 