Index: trunk/MagicSoft/Mars/msim/MSimAtmosphere.cc
===================================================================
--- trunk/MagicSoft/Mars/msim/MSimAtmosphere.cc	(revision 9370)
+++ trunk/MagicSoft/Mars/msim/MSimAtmosphere.cc	(revision 9378)
@@ -165,11 +165,13 @@
         // the observer
 
+        // FIXME: Could be replaced by 0, AtmLay[0]-fAtmLay[3]
+
         const Double_t h[5] =
         {
-            fObsLevel,                       //   0km
-            TMath::Max(fObsLevel, 4e5),      //   4km
-            1.0e6,                           //  10km
-            4.0e6,                           //  40km
-            1.0e7                            // 100km
+            fObsLevel,                     // fObsLevel,                   //   0km
+            TMath::Max(fObsLevel, 7.75e5), // TMath::Max(fObsLevel, 4e5),  //   4km
+             16.5e5,                       //  10e5,                       //  10km
+             50.0e5,                       //  40e5,                       //  40km
+            105.0e5,                       // 100e5                        // 100km
         };
 
@@ -418,11 +420,13 @@
     MAtmosphere(const MCorsikaRunHeader &h) : fAbsCoeffOzone(0), fAbsCoeffAerosols(0)
     {
-        Init(h, "ozone.txt", "aerosols.txt");
-    }
-
-    MAtmosphere(const char *name1="ozone.txt", const char *name2="aerosols.txt") : fAbsCoeffOzone(0), fAbsCoeffAerosols(0)
-    {
-        InitOzone(name1);
-        InitAerosols(name2);
+        Init(h);//, "ozone.txt", "aerosols.txt");
+    }
+
+    MAtmosphere(const char *name1=0, const char *name2=0) : fAbsCoeffOzone(0), fAbsCoeffAerosols(0)
+    {
+        if (name1)
+            InitOzone(name1);
+        if (name2)
+            InitAerosols(name2);
     }
 
@@ -694,5 +698,7 @@
 //
 MSimAtmosphere::MSimAtmosphere(const char* name, const char *title)
-    : fEvt(0), fAtmosphere(0)
+    : fEvt(0), fAtmosphere(0),
+    fFileAerosols("resmc/atmosphere-aerosols.txt"),
+    fFileOzone("resmc/atmosphere-ozone.txt")
 {
     fName  = name  ? name  : "MSimAtmosphere";
@@ -753,5 +759,5 @@
     */
 
-    fAtmosphere->Init(*h);
+    fAtmosphere->Init(*h, fFileOzone, fFileAerosols);
 
     if (!fAtmosphere->IsAllValid())
@@ -847,23 +853,23 @@
 // --------------------------------------------------------------------------
 //
-// FileName: reflectivity.txt
-// UseTheta: No
+// FileAerosols: resmc/atmosphere-aerosols.txt
+// FileOzone:    resmc/atmosphere-ozone.txt
 //
 Int_t MSimAtmosphere::ReadEnv(const TEnv &env, TString prefix, Bool_t print)
 {
     Bool_t rc = kFALSE;
-/*
-    if (IsEnvDefined(env, prefix, "FileName", print))
+
+    if (IsEnvDefined(env, prefix, "FileAerosols", print))
     {
         rc = kTRUE;
-        SetFileName(GetEnvValue(env, prefix, "FileName", fFileName));
-    }
-
-    if (IsEnvDefined(env, prefix, "UseTheta", print))
+        fFileAerosols = GetEnvValue(env, prefix, "FileAerosols", fFileAerosols);
+    }
+
+    if (IsEnvDefined(env, prefix, "FileOzone", print))
     {
         rc = kTRUE;
-        SetUseTheta(GetEnvValue(env, prefix, "UseTheta", fUseTheta));
-    }
-*/
+        fFileOzone = GetEnvValue(env, prefix, "FileOzone", fFileOzone);
+    }
+
     return rc;
 }
Index: trunk/MagicSoft/Mars/msim/MSimAtmosphere.h
===================================================================
--- trunk/MagicSoft/Mars/msim/MSimAtmosphere.h	(revision 9370)
+++ trunk/MagicSoft/Mars/msim/MSimAtmosphere.h	(revision 9378)
@@ -17,4 +17,7 @@
     MAtmosphere  *fAtmosphere; //! Instance of class describing atmosphere
 
+    TString fFileAerosols;     // Name of file with aersole absorption
+    TString fFileOzone;        // Name of file with ozone absorption
+
     // MParContainer
     Int_t ReadEnv(const TEnv &env, TString prefix, Bool_t print=kFALSE);
@@ -29,8 +32,4 @@
     ~MSimAtmosphere();
 
-    // MSimAtmosphere
-
-    // TObject
-
     ClassDef(MSimAtmosphere, 0) // Simulate the wavelength and height-dependant atmpsheric absorption
 };